Subject: [core] Fwd: CoAP over TCP

From: Carsten Bormann <[email-masked]>
Date: Mon, 10 Nov 2014 13:03:21 -1000

Just sent this reply off-list; the points are maybe of general interest to this list.

Grüße, Carsten

> Begin forwarded message:
> 
> Subject: Re: [core] CoAP over TCP
> From: Carsten Bormann <[email-masked]>
> Date: 10 Nov 2014 12:40:44 -1000
> To: 고석갑 <[email-masked]>
> 
> On 10 Nov 2014, at 12:28, 고석갑 <[email-masked]> wrote:
>> 
>> I think coap message formats should compatible with over-udp and with over-tcp. Keeping the same format against transport is better. For an example, there is a coap-to-coap proxy for converting media. The proxy can relay coap message from tcp to udp. 
> 
> Hi 고석갑,
> 
> thank you for your input.
> 
> A simple copy only works for a one-to-one relationship between UDP endpoint pairs and TCP connections.  Most proxies need to multiplex or demultiplex, and carrying around message layer fields that aren’t actually needed on the TCP side will cause a lot of interoperability problems:
> Some implementations will fill then in haphazardly (e.g., by copying from the UDP side), and other implementations will rely on them having correct values.  So I would strongly recommend against carrying message-IDs (or message types) on the TCP side.
> 
> On the delimiting discussion, I get the impression that a length field is indeed preferred by many people.  So the next question will be: fixed vs. variable size lengths, and if fixed, fixed at 4 (Hannes’ draft) or fixed at 2 (see section 4.6 of RFC 7252).
> 
> Can I forward this reply to the list?  You seem to have sent your message to me personally.
> 
> Grüße, Carsten